net.sourceforge.pmd.dcd.graph

## Class UsageGraph

- java.lang.Object
- - net.sourceforge.pmd.dcd.graph.UsageGraph

All Implemented Interfaces:
  NodeVisitorAcceptor

    public class UsageGraph
    extends Object
    implements NodeVisitorAcceptor

A UsageGraph tracks usage references between Java classes, based upon a parsing of the class files. Once the UsageGraph is built, it may be visited to perform additional post-processing, or usage relationship analysis.

The UsageGraph is composed of ClassNodes. Each ClassNode has various MemberNodes, specifically ConstructorNodes, FieldNodes, and MethodNodes. Each of these MemberNodes keeps track of other MemberNodes which it uses and other MemberNodes which are users of it. In this sense, the graph can navigated bi-directionally across the use relationship between MemberNodes.

Great effort is taken to keep the bookkeeping of the UsageGraph as tight as possible, so that rather large code bases can be analyzed. While nodes can grant access to the underlying Java Reflection APIs (e.g. Class, Constructor, Field, Member), the results are stored using WeakReferences to assist with memory usage.

A class Filter can be specified to limit the set of classes on which usage references will be tracked. This is often done to limit memory usage to interesting classes. For example, the `java.util` package is very often used, and tracking usages would require a massive bookkeeping effort which has little value.

See Also:
  `UsageGraphBuilder`, `ClassNode`, `MemberNode`, `ConstructorNode`, `FieldNode`, `MethodNode`, `NodeVisitor`, `NodeVisitorAcceptor`

### Field Summary

Fields
`protected Filter<String>` `classFilter`

### Constructor Summary

Constructors
Constructor and Description
`UsageGraph(Filter<String> classFilter)`

### Method Summary

Methods
`Object` `accept(NodeVisitor visitor, Object data)`
`ClassNode` `defineClass(String className)`
`MemberNode` `defineConstructor(String className, String name, String desc)`
`FieldNode` `defineField(String className, String name, String desc)`
`MemberNode` `defineMethod(String className, String name, String desc)`
`boolean` `isClass(String className)`
`void` `usageField(String className, String name, String desc, MemberNode usingMemberNode)`
`void` `usageMethod(String className, String name, String desc, MemberNode usingMemberNode)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### classFilter

    protected final Filter<String> classFilter

### Constructor Detail

#### UsageGraph

    public UsageGraph(Filter<String> classFilter)

### Method Detail

#### accept

    public Object accept(NodeVisitor visitor,
                Object data)

Specified by:
  `accept` in interface `NodeVisitorAcceptor`

#### isClass

    public boolean isClass(String className)

#### defineClass

    public ClassNode defineClass(String className)

#### defineField

    public FieldNode defineField(String className,
                        String name,
                        String desc)

#### defineConstructor

    public MemberNode defineConstructor(String className,
                               String name,
                               String desc)

#### defineMethod

    public MemberNode defineMethod(String className,
                          String name,
                          String desc)

#### usageField

    public void usageField(String className,
                  String name,
                  String desc,
                  MemberNode usingMemberNode)

#### usageMethod

    public void usageMethod(String className,
                   String name,
                   String desc,
                   MemberNode usingMemberNode)